'include file for myCalc ver 1.26
'-------------------------------------------------------------------------

$ver = "ver 1.26"

%IDC_Digits             = 2000  '0 thru 9
%IDC_MPos               = 2020  'A
%IDC_MNeg               = 2021  'B
%IDC_MRcl               = 2022  'C
%IDC_Hist               = 2023  'D
%IDC_Undo               = 2024  'E
%IDC_MClr               = 2025  'F

%IDC_Places             = 2100
%IDC_Point              = 2101
%IDC_Sign               = 2102
%IDC_Pct                = 2103
%IDC_Inv                = 2104
%IDC_Add                = 2105
%IDC_Sub                = 2106
%IDC_Mult               = 2107
%IDC_Div                = 2108
%IDC_Equal              = 2109

%IDC_CE                 = 2200
%IDC_Entry              = 2202
%IDC_Mem                = 2203
%IDC_Op                 = 2204

%IDC_HistLB             = 2300
%IDC_HistPrn            = 2301
%IDC_Dec                = 2400
%IDC_Hex                = 2401
%IDC_Quit               = 2402

%IDM_Help               = 2201

TYPE HistStruct
   op AS INTEGER
   q AS EXT
   qResult AS EXT
   hex AS BYTE
END TYPE

UNION varConvert
   q AS QUAD
   d(1 TO 2) AS DWORD
END UNION

'GLOBAL dbug AS LONG
GLOBAL hCalc AS LONG
GLOBAL hEntry AS LONG
GLOBAL hHist AS LONG
GLOBAL nHist AS INTEGER
GLOBAL Hist() AS HistStruct
GLOBAL sOp() AS STRING
GLOBAL sDec AS STRING
GLOBAL dec() AS STRING
GLOBAL ac() AS ACCELAPI
GLOBAL bc() AS ACCELAPI
GLOBAL hexMode AS LONG
GLOBAL edt AS LONG
GLOBAL result AS BYTE
GLOBAL showHist AS BYTE

DECLARE CALLBACK FUNCTION calculatorProc()
DECLARE CALLBACK FUNCTION historyProc()
DECLARE CALLBACK FUNCTION okHelp()
DECLARE FUNCTION subClassEntry(BYVAL LONG, BYVAL LONG, BYVAL LONG, BYVAL LONG) AS LONG
DECLARE FUNCTION calculate(EXT, EXT, INTEGER) AS EXT
DECLARE FUNCTION MakeFont(LONG, STRING, BYVAL LONG) AS LONG
DECLARE FUNCTION myHex(EXT) AS STRING
DECLARE SUB printText(BYVAL LONG, STRING, DOUBLE, DOUBLE, LONG)
DECLARE SUB showHelp()
DECLARE SUB History()
DECLARE SUB HistFill()
DECLARE SUB HistPrint(LONG)
DECLARE SUB initCalc()

SUB calculator
   LOCAL STYLE AS LONG, dlgHt AS LONG, dlgWidth AS LONG
   LOCAL i AS LONG, x AS LONG, y AS LONG
   DIM dec(10) AS STRING
   STYLE = %WS_SYSMENU OR %WS_MINIMIZEBOX
   dlgHt = 215: dlgWidth = 160
   DIALOG NEW 0, "Calculator", , , dlgWidth, dlgHt, STYLE TO hCalc
   DIALOG SET COLOR hCalc, -1, %LTGRAY
   STYLE = %WS_TABSTOP OR %ES_LEFT OR %ES_NUMBER
   CONTROL ADD TEXTBOX, hCalc, %IDC_Entry, "", 10, 10, 90, 15, STYLE, %WS_EX_CLIENTEDGE
   CONTROL ADD LABEL, hCalc, %IDC_Mem, "", 102, 9, 9, 12
   CONTROL SET COLOR hCalc, %IDC_Mem, %RED, %LTGRAY
   CONTROL ADD LABEL, hCalc, %IDC_Op, "", 102, 17, 9, 12
   CONTROL SET COLOR hCalc, %IDC_Op, %RED, %LTGRAY
   STYLE = %CBS_DROPDOWNLIST OR %WS_TABSTOP
   CONTROL ADD COMBOBOX, hCalc, %IDC_Places, , 35, 35, 25, 100, STYLE
   CONTROL ADD LABEL, hCalc, -1, "  Dec" + $CRLF + "Places", 10, 34, 25, 20
   CONTROL SET COLOR hCalc, -1, %BLACK, %LTGRAY
   STYLE = %WS_TABSTOP
   CONTROL ADD OPTION, hCalc, %IDC_Dec, "Dec", 72, 32, 25, 10, STYLE
   CONTROL ADD OPTION, hCalc, %IDC_Hex, "Hex", 72, 42, 25, 10
   CONTROL SET COLOR hCalc, %IDC_Dec, %BLACK, %LTGRAY
   CONTROL SET COLOR hCalc, %IDC_Hex, %BLACK, %LTGRAY
   y = 150
   CONTROL ADD BUTTON, hCalc, %IDC_Mpos, "", 10, y, 30, 20, STYLE OR %WS_GROUP
   CONTROL ADD BUTTON, hCalc, %IDC_Mneg, "", 40, y, 30, 20, STYLE
   CONTROL ADD BUTTON, hCalc, %IDC_MRcl, "", 70, y, 30, 20, STYLE
   y = 170
   CONTROL ADD BUTTON, hCalc, %IDC_Hist, "", 10, y, 30, 20, STYLE
   CONTROL ADD BUTTON, hCalc, %IDC_Undo, "", 40, y, 30, 20, STYLE
   CONTROL ADD BUTTON, hCalc, %IDC_MClr, "", 70, y, 30, 20, STYLE
   STYLE = %BS_CENTER
   CONTROL ADD BUTTON, hCalc, %IDC_CE, "&C/CE", 112, 10, 35, 20, STYLE
   FOR i = 1 TO 9
      x = 10 + 30 * ((i - 1) MOD 3): y = 100 - 20 * INT((i - 1)/3)
      CONTROL ADD BUTTON, hCalc, %IDC_Digits + i, STR$(i), x, y, 30, 20, STYLE
   NEXT i
   y =120
   CONTROL ADD BUTTON, hCalc, %IDC_Digits, "0", 10, y, 30, 20, STYLE
   CONTROL ADD BUTTON, hCalc, %IDC_Point, ".", 40, y, 30, 20, STYLE
   CONTROL ADD BUTTON, hCalc, %IDC_Pct, "%", 70, y, 30, 20, STYLE
   CONTROL ADD LINE, hCalc, -1, "", 3, 144, 148, 2
   x = 112
   CONTROL ADD BUTTON, hCalc, %IDC_Div, "/", x, 40, 35, 20, STYLE
   CONTROL ADD BUTTON, hCalc, %IDC_Mult, "x", x, 60, 35, 20, STYLE
   CONTROL ADD BUTTON, hCalc, %IDC_Sub, "-", x, 80, 35, 20, STYLE
   CONTROL ADD BUTTON, hCalc, %IDC_Add, "+", x, 100, 35, 20, STYLE
   CONTROL ADD BUTTON, hCalc, %IDC_Equal, "=", x, 120, 35, 20, STYLE
   CONTROL ADD BUTTON, hCalc, %IDC_Sign, "Sg&n", x, 150, 35, 20, STYLE
   CONTROL ADD BUTTON, hCalc, %IDC_Inv, "&Inv", x, 170, 35, 20, STYLE
   CONTROL ADD BUTTON, hCalc, %IDC_Quit, "", 0, 0, 0, 0, STYLE
   DIALOG SHOW MODAL hCalc, CALL calculatorProc
END SUB

CALLBACK FUNCTION calculatorProc()
   LOCAL hInst AS LONG, hIcon AS LONG, i AS LONG, n AS LONG, hSysMenu AS LONG
   LOCAL s AS STRING, t AS ASCIIZ*2, nStor AS BYTE, qStor AS EXT
   LOCAL orig AS LONG, szOrigWndProc AS ASCIIZ*12
   STATIC sEntry AS STRING, sView AS STRING
   STATIC q AS EXT, qResult AS EXT, qLast AS EXT, qSav AS EXT
   STATIC op AS INTEGER, nDec AS BYTE, newProb AS BYTE
   STATIC opSav AS INTEGER, opLast AS INTEGER, qMem AS EXT
   STATIC hdc AS LONG, hOrigFont AS LONG, hFont AS LONG
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         DIM sOp(5), Hist(0), dec(5)
         sOp(0) = " ": sOp(1) = "+": sOp(2) = "-":
         sOp(3) = "x": sOp(4) = "/": sOp(5) = "="
         dec(0) = "M+": dec(1) = "M-": dec(2) = "MR"
         dec(3) = "Hist": dec(4) = "Undo": dec(5) = "MC"
         hInst = GetModuleHandle(BYVAL %NULL)
         hIcon = LoadImage(hInst, "calcICON", %IMAGE_ICON, 0, 0, %LR_DEFAULTSIZE)
         DIALOG SEND CBHNDL, %WM_SETICON, %ICON_BIG, hIcon
         sEntry = "": newProb = 1
         hdc=GetDc(CBHNDL)
         hFont = makeFont(hDC, "Courier New", 10)
         hOrigFont = SelectObject(hdc, hFont)
         FOR i = %IDC_Pct TO %IDC_Equal
            CONTROL SEND CBHNDL, i, %WM_SETFONT, hFont, 1
         NEXT i
         CONTROL SEND CBHNDL, %IDC_Point, %WM_SETFONT, hFont, 1
         CONTROL SEND CBHNDL, %IDC_Sign, %WM_SETFONT, hFont, 1
         CONTROL SEND CBHNDL, %IDC_Op, %WM_SETFONT, hFont, 1
         FOR i = 0 TO 8
            COMBOBOX ADD CBHNDL, %IDC_Places, STR$(i)
         NEXT i
         COMBOBOX SELECT CBHNDL, %IDC_Places, 3
         CONTROL SET OPTION hCalc, %IDC_Dec, %IDC_Dec, %IDC_Hex
         nDec = 2: sDec = "#0.00"
         '----------------------------------------------------------
         DIM ac(0:32) 'accelerator keys for decimal calc
         DIM bc(0:36) 'accelerator keys for hex calc
         FOR i = 0 TO 9
            ac(i).fvirt = %FVIRTKEY
            ac(i).key = %VK_0 + i
            ac(i).cmd = %IDC_Digits + i
            ac(i+22).fvirt = %FVIRTKEY
            ac(i+22).key = %VK_NUMPAD0 + i
            ac(i+22).cmd = %IDC_Digits + i
         NEXT i
         ac(10).fvirt = %FVIRTKEY    :   ac(16).fvirt = 0
         ac(10).key = %VK_Decimal    :   ac(16).key = 46
         ac(10).cmd = %IDC_Point     :   ac(16).cmd = %IDC_Point
         ac(11).fvirt = %FVIRTKEY    :   ac(17).fvirt = 0
         ac(11).key = %VK_ADD        :   ac(17).key = 43
         ac(11).cmd = %IDC_Add       :   ac(17).cmd = %IDC_Add
         ac(12).fvirt = %FVIRTKEY    :   ac(18).fvirt = 0
         ac(12).key = %VK_SUBTRACT   :   ac(18).key = 45
         ac(12).cmd = %IDC_Sub       :   ac(18).cmd = %IDC_Sub
         ac(13).fvirt = %FVIRTKEY    :   ac(19).fvirt = 0
         ac(13).key = %VK_MULTIPLY   :   ac(19).key = 42
         ac(13).cmd = %IDC_Mult      :   ac(19).cmd = %IDC_Mult
         ac(14).fvirt = %FVIRTKEY    :   ac(20).fvirt = 0
         ac(14).key = %VK_DIVIDE     :   ac(20).key = 47
         ac(14).cmd = %IDC_Div       :   ac(20).cmd = %IDC_Div
         ac(15).fvirt = %FVIRTKEY    :   ac(21).fvirt = 0
         ac(15).key = %VK_ESCAPE     :   ac(21).key = 37
         ac(15).cmd = %IDC_Quit      :   ac(21).cmd = %IDC_Pct

         ac(32).fvirt = %FVIRTKEY
         ac(32).key = %VK_F1
         ac(32).cmd = %IDM_Help
         '----------------------------------------------------------
         FOR i = 0 TO 9
            bc(i).fvirt = %FVIRTKEY
            bc(i).key = %VK_0 + i
            bc(i).cmd = %IDC_Digits + i
            bc(i+26).fvirt = %FVIRTKEY
            bc(i+26).key = %VK_NUMPAD0 + i
            bc(i+26).cmd = %IDC_Digits + i
         NEXT i
         bc(10).fVirt = %FVIRTKEY    :   bc(11).fVirt = %FVIRTKEY
         bc(10).key = %VK_A          :   bc(11).key = %VK_B
         bc(10).cmd = %IDC_MPos      :   bc(11).cmd = %IDC_MNeg
         bc(12).fVirt = %FVIRTKEY    :   bc(13).fVirt = %FVIRTKEY
         bc(12).key = %VK_C          :   bc(13).key = %VK_D
         bc(12).cmd = %IDC_MRcl      :   bc(13).cmd = %IDC_Hist
         bc(14).fVirt = %FVIRTKEY    :   bc(15).fVirt = %FVIRTKEY
         bc(14).key = %VK_E          :   bc(15).key = %VK_F
         bc(14).cmd = %IDC_Undo      :   bc(15).cmd = %IDC_MClr
         bc(16).fvirt = %FVIRTKEY    :   bc(17).fvirt = 0
         bc(16).key = %VK_ADD        :   bc(17).key = 43
         bc(16).cmd = %IDC_Add       :   bc(17).cmd = %IDC_Add
         bc(18).fvirt = %FVIRTKEY    :   bc(19).fvirt = 0
         bc(18).key = %VK_SUBTRACT   :   bc(19).key = 45
         bc(18).cmd = %IDC_Sub       :   bc(19).cmd = %IDC_Sub
         bc(20).fvirt = %FVIRTKEY    :   bc(21).fvirt = 0
         bc(20).key = %VK_MULTIPLY   :   bc(21).key = 42
         bc(20).cmd = %IDC_Mult      :   bc(21).cmd = %IDC_Mult
         bc(22).fvirt = %FVIRTKEY    :   bc(23).fvirt = 0
         bc(22).key = %VK_DIVIDE     :   bc(23).key = 47
         bc(22).cmd = %IDC_Div       :   bc(23).cmd = %IDC_Div
         bc(24).fvirt = %FVIRTKEY
         bc(24).key = %VK_RETURN
         bc(24).cmd = %IDC_Equal
         bc(25).fvirt = %FVIRTKEY
         bc(25).key = %VK_ESCAPE
         bc(25).cmd = %IDC_CE
         bc(36).fvirt = %FVIRTKEY
         bc(36).key = %VK_F1
         bc(36).cmd = %IDM_Help
         '----------------------------------------------------------
         initCalc: edt = 1
         'subclass textbox %IDC_Entry
         CONTROL HANDLE CBHNDL, %IDC_Entry TO hEntry
         orig = SetWindowLong(hEntry, %GWL_WNDPROC, CODEPTR(subClassEntry))
         szOrigWndProc = "OrigWndProc"
         SetProp hEntry, szOrigWndProc, orig
         '----------------------------------------------------------
         hSysMenu = GetSystemMenu(CBHNDL, 0)
         InsertMenu hSysMenu, 0, %MF_BYPOSITION OR %MF_STRING, %IDM_Help, "&Help" + $TAB + "F1"
         RemoveMenu hSysMenu, 4, %MF_BYPOSITION
         RemoveMenu hSysMenu, 3, %MF_BYPOSITION
         RemoveMenu hSysMenu, 2, %MF_BYPOSITION
         RemoveMenu hSysMenu, 1, %MF_BYPOSITION
         RemoveMenu hSysMenu, 1, %MF_BYPOSITION
         DrawMenuBar CBHNDL
      CASE %WM_COMMAND
         IF CBCTL = %IDC_Places THEN
            IF CBCTLMSG = %CBN_SELENDOK THEN
               CONTROL GET TEXT CBHNDL, %IDC_Places TO s
               nDec = VAL(s): sDec = "#0": IF nDec THEN sDec = "#0."
               sDec = sDec + STRING$(nDec, "0")
               q = VAL(sView): IF edt THEN q = VAL(sEntry)
               IF qResult THEN q = qResult
               sView = FORMAT$(q, sDec)
               IF LEN(sEntry) = 0 THEN
                  CONTROL SET TEXT hCalc, %IDC_Entry, sView
               END IF
               IF showHist THEN HistFill
            END IF
         ELSEIF CBCTLMSG = %EN_SETFOCUS THEN
            IF edt = 0 THEN
               HideCaret hEntry
               IF op THEN CONTROL SET TEXT CBHNDL, %IDC_Op, sOp(op)
            ELSE
               CONTROL SEND CBHNDL, %IDC_Entry, %EM_SETSEL, -1, 0
            END IF
         ELSEIF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
            IF CBCTL = 1 THEN EXIT FUNCTION
            IF CBCTL >= %IDC_Add AND CBCTL <= %IDC_Equal THEN
               s = sOp(CBCTL - %IDC_Add + 1)
               CONTROL SET TEXT CBHNDL, %IDC_Op, s
            END IF
            IF CBCTL <= %IDC_Digits + 9 OR CBCTL = %IDC_Point THEN
               n = CBCTL - %IDC_Digits: t = TRIM$(STR$(n))
               IF CBCTL = %IDC_Point THEN t = "."
               IF op = 0 THEN
                  newProb = 1: CONTROL SET TEXT CBHNDL, %IDC_Op, ""
               END IF
               IF LEN(sEntry) = 0 THEN
                  CONTROL SET TEXT CBHNDL, %IDC_Entry, ""
               END IF
               CONTROL SEND CBHNDL, %IDC_Entry, %EM_REPLACESEL, 0, VARPTR(t)
               CONTROL GET TEXT CBHNDL, %IDC_Entry TO sEntry
               CONTROL SET TEXT CBHNDL, %IDC_Op, ""
               result = 3: edt = 1: opLast = 0
            ELSEIF CBCTL <= %IDC_MClr AND hexMode THEN
               n = CBCTL - %IDC_MPos + 65
               IF op = 0 THEN newProb = 1
               t = CHR$(n)
               IF LEN(sEntry) = 0 THEN
                  CONTROL SET TEXT CBHNDL, %IDC_Entry, ""
               END IF
               CONTROL SEND CBHNDL, %IDC_Entry, %EM_REPLACESEL, 0, VARPTR(t)
               CONTROL GET TEXT CBHNDL, %IDC_Entry TO sEntry
               CONTROL SET TEXT CBHNDL, %IDC_Op, ""
               result = 3: edt = 1: opLast = 0
            ELSEIF CBCTL = %IDC_Sign OR CBCTL = %IDC_Inv THEN
               IF LEN(sEntry) THEN q = VAL(sEntry)
               IF q = 0 THEN EXIT IF
               IF CBCTL = %IDC_Sign THEN q = -q ELSE q = 1/q
               result = 2: edt = 0
               IF newProb = 0 AND op = 0 THEN
                  result = 1: qResult = q: op = 5
               END IF
               sView = FORMAT$(q, sDec): sEntry = ""
            ELSEIF CBCTL = %IDC_Pct THEN
               IF LEN(sEntry) THEN q = VAL(sEntry)
               IF q = 0 THEN EXIT IF
               q = q / 100: result = 2: edt = 0
               IF op AND op <= 2 THEN
                  q = calculate(qResult, q, 3)
               ELSEIF newProb = 0 AND op = 0 THEN
                  qResult = q: op = 5
               END IF
               sView = FORMAT$(q, sDec): sEntry = ""
            ELSEIF CBCTL = %IDC_Dec OR CBCTL = %IDC_Hex THEN
               hexMode = 1 - hexMode: initCalc
               CONTROL SET OPTION hCalc, %IDC_Dec + hexMode, %IDC_Dec, %IDC_Hex
               CONTROL GET TEXT CBHNDL, %IDC_Entry TO s
               IF hexMode THEN
                  q = VAL(s): sView = myHex(q)
               ELSE
                  IF edt THEN q = VAL("&H" + s)
                  sView = TRIM$(STR$(q, 18))
               END IF
               result = 0: sEntry = "": edt = 0
            ELSEIF CBCTL = %IDC_MPos THEN
               IF LEN(sEntry) THEN q = VAL(sEntry)
               qMem = qMem + q: result = 2: edt = 0
               CONTROL SET TEXT CBHNDL, %IDC_Mem, "M"
               sEntry = "": sView = FORMAT$(q, sDec)
            ELSEIF CBCTL = %IDC_MNeg THEN
               IF LEN(sEntry) THEN q = VAL(sEntry)
               qMem = qMem - q: result = 2: edt = 0
               CONTROL SET TEXT CBHNDL, %IDC_Mem, "M"
               sEntry = "": sView = FORMAT$(q, sDec)
            ELSEIF CBCTL = %IDC_MRcl THEN
               result = 2: q = qMem: edt = 0
               sView = FORMAT$(qMem, sDec): sEntry = ""
               CONTROL SET TEXT CBHNDL, %IDC_Entry, sView
            ELSEIF CBCTL = %IDC_MClr THEN
               qMem = 0
               CONTROL SET TEXT CBHNDL, %IDC_Mem, " "
            ELSEIF CBCTL >= %IDC_Add AND CBCTL <= %IDC_Div THEN
               IF edt THEN CONTROL GET TEXT CBHNDL, %IDC_Entry TO sEntry
               IF LEN(sEntry) THEN
                  IF hexMode THEN sEntry = "&H0" + sEntry
                  q = VAL(sEntry): IF qResult THEN qLast = q
               END IF
               IF newProb OR op = 0 THEN
                  qResult = q
               ELSE
                  qResult = calculate(qResult, q, op)
               END IF
               op = CBCTL - %IDC_Add + 1
               opLast = op: result = 1
            ELSEIF CBCTL = %IDC_Equal THEN
               IF hexMode AND LEN(sEntry) THEN sEntry = "&H0" + sEntry
               IF op = 0 AND opLast = 0 AND opSav = 0 THEN
                  'number entered with equal
                  'before repeating calc number has been established
                  result = 99: q = VAL(sEntry): edt = 0
                  sView = FORMAT$(q, sDec): sEntry = ""
                  IF hexMode THEN sView = myHex(q)
                  CONTROL SET TEXT CBHNDL, %IDC_Op, ""
               END IF: IF result = 99 THEN result = 2: EXIT IF
               IF LEN(sEntry) THEN q = VAL(sEntry): qLast = q
               IF op AND qLast THEN opSav = op: qSav = qLast
               IF op = 0 OR opLast THEN
                  IF opSav THEN 'repeated calcs with last operated number
                     IF op = 0 THEN 'e.g. [4 + 5 = x 3 = ], [7 = ] ... 21
                        qResult = q: qStor = qResult: nStor = 1
                        q = qSav: op = opSav
                     ELSE 'op followed immediately by equal
                          'e.g. [4 + 5 + = ] ... 14
                        opLast = 0
                     END IF
                  ELSE 'define 2nd number and op for repeated calcs
                       'e.g. [5 / = ] ... 1 / 5 = .20
                     qResult = 0: op = opLast
                     IF op = 3 THEN qResult = q
                     IF op = 4 THEN qResult = 1
                     hist(nHist-1).q = qResult
                     opSav = op: qSav = q
                  END IF
               END IF
               IF op THEN qResult = calculate(qResult, q, op)
               op = 5: result = 1: IF nStor THEN q = qStor
            ELSEIF CBCTL = %IDC_CE THEN
               IF edt AND LEN(sEntry) THEN 'clear entry only
                  result = 4: q = 0: sEntry = "": sView = ""
                  CONTROL SET TEXT CBHNDL, %IDC_Entry, ""
               ELSEIF nHist OR LEN(sView) OR hexMode THEN 'reset calculator
                  s = "Clear everything?": result = 3
                  n = MSGBOX(s, %MB_YESNO, "Reset Calculator")
                  IF n = %IDYES THEN
                     result = 4: edt = 1: q = 0
                     qResult = 0: qLast = 0: newProb = 1
                     opSav = 0: qSav = 0: op = 0: qMem = 0
                     nHist = 0: nDec = 2: sDec = "#0.00"
                     COMBOBOX SELECT hCalc, %IDC_Places, 3
                     CONTROL SET TEXT CBHNDL, %IDC_Mem, ""
                     CONTROL SET TEXT CBHNDL, %IDC_Op, ""
                     CONTROL SET TEXT CBHNDL, %IDC_Entry, sEntry
                     hexMode = 0: initCalc
                     sEntry = "": sView = "": result = 4
                  END IF
               END IF
            ELSEIF CBCTL = %IDC_Hist THEN
               CONTROL SEND CBHNDL, CBCTL, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE
               History: EXIT FUNCTION
            ELSEIF CBCTL = %IDC_Undo AND nHist > 1 THEN
               DECR nHist
               op = Hist(nHist).op
               q = Hist(nHist).q
               qResult = Hist(nHist).qResult
               sView = FORMAT$(q, sDec): sEntry = TRIM$(STR$(q))
               IF LEN(sEntry) > LEN(sView) THEN sView = sEntry
               result = 2: newProb = 0: edt = 1
               IF op = 5 THEN edt = 0: op = 0: s = "="
               IF edt THEN s = " "
               CONTROL SET TEXT CBHNDL, %IDC_Op, s
               IF showHist THEN HistFill
            ELSEIF CBCTL = %IDC_Quit THEN
               DIALOG END CBHNDL
            END IF
            IF result = 1 THEN
               IF newProb THEN
                  INCR nHist
                  REDIM PRESERVE Hist(nHist)
                  Hist(nHist).op = 0
                  Hist(nHist).qResult = 0
               END IF
               INCR nHist
               REDIM PRESERVE Hist(nHist)
               Hist(nHist).op = op
               Hist(nHist).qResult = qResult
               IF Hist(nHist-1).op <> 5 THEN
                  Hist(nHist-1).q = q: Hist(nHist-1).hex = hexMode
               END IF
               IF op = 5 THEN
                  Hist(nHist).q = qResult: q = qResult: op = 0
               END IF
               IF ABS(qResult) > 999999999999999999 THEN '18 digits
                  s = "Overflow": DECR nHist
                  CONTROL SET TEXT hCalc, %IDC_Entry, s: result = 3
               END IF
               IF hexMode = 0 THEN
                  sView = FORMAT$(qResult, sDec)
               ELSE
                  sView = myHex(qResult): Hist(nHist).hex = 1
               END IF
               sEntry = "": edt = 0: newProb = 0
               IF showHist THEN HistFill
            END IF
            IF CBCTL < %IDC_Dec THEN
               CONTROL SEND CBHNDL, CBCTL, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE
            END IF
            IF result <> 3 THEN CONTROL SET TEXT hCalc, %IDC_Entry, sView
            IF edt = 0 THEN 'result = 1 THEN
               edt = 0: HideCaret hEntry
               CONTROL SEND CBHNDL, %IDC_Entry, %EM_SETSEL, 0, -1
            ELSE 'IF result THEN
               edt = 1: ShowCaret hEntry
               CONTROL SEND CBHNDL, %IDC_Entry, %EM_SETSEL, -1, 0
            END IF
            CONTROL SET FOCUS CBHNDL, %IDC_Entry
         END IF
      CASE %WM_SYSCOMMAND
         IF CBWPARAM = %IDM_Help THEN showHelp
      CASE %WM_DESTROY
         DeleteObject selectObject(hdc, hOrigFont)
         ReleaseDC CBHNDL, hdc
   END SELECT
END FUNCTION

FUNCTION subClassEntry(BYVAL hWnd&, BYVAL wMsg&, BYVAL wParam&, BYVAL lParam&) AS LONG
'capture VK_RETURN key for textbox
   LOCAL szOrigWndProc AS ASCIIZ*12, n AS LONG
   szOrigWndProc = "OrigWndProc"
   SELECT CASE wMsg&
      CASE %WM_KEYUP
         IF wParam& = %VK_RETURN AND result <> 4 THEN
            DIALOG SEND hCalc, %WM_COMMAND, %IDC_Equal, 1
         END IF
      CASE %WM_DESTROY
         SetWindowLong hWnd&, %GWL_WNDPROC, GetProp(hWnd&, szOrigWndProc)
         RemoveProp hWnd&, szOrigWndProc: EXIT FUNCTION
   END SELECT
   'pass the message on to the original textbox procedure... the DDT engine!
   n = GetProp(hWnd&, szOrigWndProc)
   FUNCTION = CallWindowProc(BYVAL n, hWnd&, wMsg&, wParam&, lParam&)
END FUNCTION

FUNCTION calculate(qResult AS EXT, q AS EXT, op AS INTEGER) AS EXT
   LOCAL f AS EXT
   SELECT CASE op
      CASE 1
         f = qResult + q
      CASE 2
         f = qResult - q
      CASE 3
         f = qResult * q
      CASE 4
         IF q THEN
            f = qResult / q
         END IF
   END SELECT
   IF hexMode THEN f = FIX(f)
   FUNCTION = f
END FUNCTION

SUB History
   LOCAL ti AS STRING, STYLE AS LONG, count AS LONG
   ti = "Calculator History"
   DIALOG NEW hCalc, ti, 158, -14, 140, 215, %WS_SYSMENU TO hHist
   DIALOG SET COLOR hHist, -1, %LTGRAY
   STYLE = %WS_TABSTOP OR %WS_VSCROLL OR %LBS_NOTIFY
   STYLE = STYLE OR %LBS_MULTIPLESEL OR %LBS_EXTENDEDSEL
   CONTROL ADD LISTBOX, hHist, %IDC_HistLB, , 5, 5, 125, 170, STYLE
   CONTROL ADD BUTTON, hHist, %IDC_HistPrn, "&Print", 15, 172, 50, 20
   CONTROL ADD BUTTON, hHist, %IDCANCEL, "&Cancel", 65, 172, 50, 20
   DIALOG SHOW MODELESS hHist, CALL historyProc
   DO
      DIALOG DOEVENTS TO count
   LOOP UNTIL ISFALSE count
END SUB

CALLBACK FUNCTION historyProc
   'LOCAL i AS LONG, op AS INTEGER, s AS STRING, qShow AS EXT
   LOCAL hLB AS LONG, hdc AS LONG, hFont AS LONG  ', spac AS STRING
   STATIC maxLen AS LONG
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         hdc = GetDC(CBHNDL)
         hFont = makeFont(hdc, "Courier", 6)
         CONTROL SEND CBHNDL, %IDC_HistLB, %WM_SETFONT, hFont, 0
         ReleaseDC hLB, hdc
         HistFill
      CASE %WM_COMMAND
         IF CBCTL = %IDC_HistPrn THEN
            IF nHist THEN HistPrint(maxLen)
         ELSEIF CBCTL = %IDCANCEL THEN
            showHist = 0: DIALOG END CBHNDL
         END IF
         IF CBCTL = %IDC_HistPrn THEN
            CONTROL SEND CBHNDL, CBCTL, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE
            CONTROL SET FOCUS CBHNDL, %IDC_HistLB
         END IF
      CASE %WM_SYSCOMMAND
         IF CBCTL = %SC_CLOSE THEN
            showHist = 0: DIALOG END CBHNDL
         END IF
   END SELECT
END FUNCTION

SUB HistFill()
   LOCAL spac AS STRING, s AS STRING, i AS LONG
   LOCAL op AS INTEGER, qShow AS EXT, maxLen AS LONG
   spac = SPACE$(INSTR(-1, sDec, ".")): showHist = 1
   FOR i = 1 TO nHist
      qShow = Hist(i).q: op = Hist(i).op
      IF op = 5 THEN qShow = Hist(i).qResult
      s = FORMAT$(qShow, sDec)
      IF Hist(i).hex THEN s = myHex(qShow) + spac
      maxLen = MAX(maxLen, LEN(s))
   NEXT i
   LISTBOX RESET hHist, %IDC_HistLB
   FOR i = 1 TO nHist
      qShow = Hist(i).q: op = Hist(i).op
      IF op = 5 THEN qShow = Hist(i).qResult
      s = FORMAT$(qShow, sDec)
      IF Hist(i).hex THEN s = myHex(qShow)+ spac
      s = sOp(op) + SPACE$(maxLen - LEN(s) + 2) + s
      IF i = nHist AND op < 5 THEN s = sOp(op)
      LISTBOX ADD hHist, %IDC_HistLB, s
   NEXT i
END SUB

SUB HistPrint(maxLen AS LONG)
   LOCAL prnError AS BYTE, charHt AS DOUBLE, tm AS TEXTMETRIC
   LOCAL hFont AS LONG, fontHeight AS LONG, pgNo AS LONG
   LOCAL i AS LONG, LINES AS LONG, linesPerPg AS LONG
   LOCAL x AS DOUBLE, y AS DOUBLE, n AS LONG, s AS STRING
   LOCAL pd AS PRINTDLGAPI, di AS DOCINFO, hPrnDC AS LONG
   LOCAL op AS BYTE, printAll AS LONG, qShow AS EXT, spac AS STRING
   CONTROL SEND hHist, %IDC_HistLB, %LB_GETSELCOUNT, 0, 0 TO n
   IF n = 1 THEN n = 0  'allow one selection for selector
   IF n = 0 THEN printAll = 1
   pd.lStructSize = SIZEOF(pd)
   pd.hWndOwner = hHist
   pd.Flags = %PD_RETURNDC OR %PD_NOPAGENUMS OR %PD_HIDEPRINTTOFILE
   IF n THEN pd.flags = pd.Flags OR %PD_SELECTION
   IF printDlg(pd) THEN hPrnDC = pd.hdc ELSE EXIT SUB
   IF hPrnDC = 0 THEN prnError = 1: GOTO WrapUp
   fontHeight = 11: linesPerPg = 60
   IF StartDoc(hPrnDC, di) <= 0 THEN prnError = 2: GOTO wrapUp
   IF StartPage(hPrnDC) <= 0 THEN prnError = 3: GOTO WrapUp
   hFont = makeFont(hPrnDC, "Courier", fontHeight)
   SelectObject hPrnDC, hFont
   getTextMetrics hPrnDC, tm
   charHt = tm.tmHeight + tm.tmExternalLeading
   x = 100: y = 20: spac = SPACE$(LEN(sDec) - INSTR(sDec, "."))
   FOR i = 1 TO nHist
      CONTROL SEND hHist, %IDC_HistLB, %LB_GETSEL, i-1, 0 TO n
      IF printAll + n = 0 THEN ITERATE 'otherwise, selected line (or print all)
      IF LINES > linesPerPg THEN
         EndPage hPrnDC
         LINES = 0: y = 0
         StartPage hPrnDC
         SelectObject hPrnDC, hFont
      END IF
      IF LINES = 0 THEN 'print title
         INCR pgNo
         s = "Recorded Calculations" + "  -  " + "Page" + STR$(pgNo)
         printText hPrnDC, s, x, y, 0
         y = y + 2*charHt: LINES = 2
      END IF
      qShow = Hist(i).q: op = Hist(i).op
      IF op = 5 THEN qShow = Hist(i).qResult
      s = FORMAT$(qShow, sDec)
      IF Hist(i).hex THEN s = myHex(qShow)+ spac
      s = sOp(op) + SPACE$(maxLen - LEN(s) + 2) + s
      printText hPrnDC, s, x, y, 0
      INCR LINES: y = y + charHt
   NEXT i
   EndPage hPrnDC
   EndDoc hPrnDC
wrapUp:
   IF prnError THEN
      s = "Printing error has occurred"
      MSGBOX s, %MB_ICONERROR, "Printing Error" + STR$(prnError)
   END IF
   DeleteObject hFont
   DeleteDC hPrnDC
END SUB

SUB printText(BYVAL h AS LONG, s AS STRING, x AS DOUBLE, y AS DOUBLE, fontSize AS LONG)
   'print text with same font size (fontSize=0)
   LOCAL hFont AS LONG, hOrigFont AS LONG
   LOCAL txt AS ASCIIZ * 255
   txt = s: IF LEN(s) = 0 THEN EXIT SUB
   IF fontSize THEN
      hFont = makeFont(h, "Courier", fontSize)
      hOrigFont = SelectObject (BYVAL h, BYVAL hFont)
      TextOut BYVAL h, x, y, txt, LEN(txt)
      DeleteObject SelectObject(BYVAL h, BYVAL hOrigFont)
   ELSE
      TextOut BYVAL h, x, y, txt, LEN(txt)
   END IF
END SUB

FUNCTION MakeFont(hDC AS LONG, sFont AS STRING, BYVAL ptSize AS LONG) AS LONG
   LOCAL CyPixels AS LONG, charHt AS LONG
   CyPixels  = GetDeviceCaps(hDC, %LOGPIXELSY)
   charHt = (PtSize * CyPixels) \ 72
   FUNCTION = CreateFont(-charHt, 0, 0, 0, %FW_NORMAL, 0, 0, 0, _
             %ANSI_CHARSET, %OUT_TT_PRECIS, %CLIP_DEFAULT_PRECIS, _
             %DEFAULT_QUALITY, %FF_DONTCARE, BYCOPY sFont)
END FUNCTION

SUB initCalc
   LOCAL i AS LONG, hAttach AS LONG
   IF hexMode THEN
      ACCEL ATTACH hCalc, bc() TO hAttach
      FOR i = %IDC_Places TO %IDC_Inv
         CONTROL DISABLE hCalc, i
      NEXT i
      FOR i = 0 TO 5
         CONTROL SET TEXT hCalc, %IDC_MPos + i, CHR$(65 + i)
      NEXT i
      CONTROL SET OPTION hCalc, %IDC_Hex, %IDC_Dec, %IDC_Hex
   ELSE
      ACCEL ATTACH hCalc, ac() TO hAttach
      FOR i = %IDC_Places TO %IDC_Inv
         CONTROL ENABLE hCalc, i
      NEXT i
      FOR i = 0 TO 5
         CONTROL SET TEXT hCalc, %IDC_MPos + i, dec(i)
      NEXT i
      CONTROL SET OPTION hCalc, %IDC_Dec, %IDC_Dec, %IDC_Hex
   END IF
   CONTROL SET FOCUS hCalc, %IDC_Entry
END SUB

FUNCTION MyHex(x AS EXT) AS STRING
   LOCAL v AS varConvert, s AS STRING
   v.q = FIX(x): IF v.d(2) THEN s = HEX$(v.d(2))
   s = s + HEX$(v.d(1))
   IF LEFT$(s, 1) >= "A" THEN s = "0" + s
   FUNCTION = s + "h"
END FUNCTION

SUB showHelp
   LOCAL hHelp AS LONG, ti AS STRING, s AS STRING, h AS LONG, count AS LONG
   ti = "Calculator by Charles Dietz - " + $ver
   s = "Examples of standard 4 function calcultor" + $CRLF
   s = s + "[12] [+] [13] [-] [7] [x] [4] [Inv] [=] ... 4.50" + $CRLF + $CRLF
   s = s + "7.5% tax on $10.50 item" + $CRLF
   s = s + "[10.5] [+] [7.5] [%] [=] ... 11.29" + $CRLF + $CRLF
   s = s + "Repeated calculations using last operand for repeat" + $CRLF
   s = s + "e.g. multiply 3.5 by 10, 20, 30" + $CRLF
   s = s + "[10] [x] [3.5] [=] [20] [=] [30] [=] ... 35, 70, 105" + $CRLF + $CRLF
   s = s + "Integer powers of 15.36" + $CRLF
   s = s + "squaring:  [15.36] [x] [=] ... 235.9296" + $CRLF
   s = s + "cubing:    [15.36] [x] [=][=] ... 3623.878656" + $CRLF + $CRLF
   s = s + "Using [M+, M-, MR, MC] functions" + $CRLF
   s = s + "e.g.  (10 + 15) * (13 + 16)" + $CRLF
   s = s + "[10] [M+] [15] [M+] [13] [+] [16] [=] [*] [MR] [=] ... 725.00"
   s = s + $CRLF + $CRLF
   s = s + "Toggle Hex/Dec modes" + $CRLF
   s = s + "[Hex] [A256] [Dec] ...  -23978" + $CRLF
   s = s + "[Hex] [0A256] [Dec] ... 41558 (note leading zero)"
   h = 215
   DIALOG NEW hCalc, ti, 20, 0, 190, h TO hHelp
   DIALOG SET COLOR hHelp, -1, %WHITE
   CONTROL ADD LABEL, hHelp, -1, s, 5, 5, 180, h - 10
   CONTROL SET COLOR hHelp, -1, %BLACK, %WHITE
   'CONTROL ADD BUTTON, hHelp, %IDOK, "Ok", 60, h - 35, 70, 25, %BS_DEFAULT CALL OkHelp
   DIALOG SHOW MODELESS hHelp, CALL helpProc
   DO
      DIALOG DOEVENTS TO count
   LOOP UNTIL ISFALSE count
END SUB

CALLBACK FUNCTION helpProc()
   SELECT CASE CBMSG
   CASE %WM_COMMAND
      IF CBCTL = %IDOK OR CBCTL = %IDCANCEL THEN
         DIALOG END CBHNDL: result = 4
         CONTROL SEND hCalc, %IDC_Entry, %EM_SETSEL, -1, 0
         IF edt = 0 THEN HideCaret hEntry
      END IF
   END SELECT
END FUNCTION

'Notes:
'edt = 0  entry editing disabled
'    = 1  entry editing enabled
'result = 0 toggle hex/dec
'       = 1 update Hist() AND display result
'       = 2 display result
'       = 3 pass thru rest of callback with no display
'       = 4 for reset calculator or clear entry, no Return key
'       = 5 hex mode checkbox
'qSav   = repeated amt
'opSav  = repeated op
'opLast = last op (zero if entering number)
'qLast  = last number entered
